/* Primitive.h,v 1.4 1995/11/30 04:22:23 pgw Exp */
/*
 Copyright (C) 1993, 1994 Jettero Heller
 Copyright (C) 1994, 1995 Peter Williams
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public License 
 version 2 as published by the Free Software Foundation.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; see the file COPYING.  If not,
 write to the Free Software Foundation, Inc., 675 Mass Ave, 
 Cambridge, MA 02139, USA.
*/


#if !defined(_XARM_PRIMITIVE_H_)
#define _XARM_PRIMITIVE_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Core.h>

class PrimitiveClass : public CoreClass {
 protected:
   PrimitiveClass() {} /* only a derived class can make this */
 public:
   /* callbacks */
   void helpCallback(XtCallbackProc funcp, XtPointer data = NULL);

   /* resources */
   void bottomShadowColor(Pixel);
   Pixel bottomShadowColor();
   void bottomShadowPixmap(Pixmap);
   Pixmap bottomShadowPixmap();
   void foreground(Pixel);
   Pixel foreground();
   void highlightColor(Pixel);
   Pixel highlightColor();
   void highlightOnEnter(Boolean);
   Boolean highlightOnEnter();
   void highlightPixmap(Pixmap);
   Pixmap highlightPixmap();
   void highlightThickness(Dimension);
   Dimension highlightThickness();
   void navigationType(XmNavigationType);
   XmNavigationType navigationType();
   void shadowThickness(Dimension);
   Dimension shadowThickness();
   void topShadowColor(Pixel);
   Pixel topShadowColor();
   void topShadowPixmap(Pixmap);
   Pixmap topShadowPixmap();
   void traversalOn(Boolean on); 
   Boolean traversalOn(); 
   void unitType(unsigned char c);
   unsigned char unitType();
   void userData(XtPointer udata);
   XtPointer userData(); 
};

#endif
