/* VendorS.h,v 1.6 1995/11/30 04:22:42 pgw Exp */
/*
 Copyright (C) 1993, 1994 Jettero Heller
 Copyright (C) 1994, 1995 Peter Williams
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public License 
 version 2 as published by the Free Software Foundation.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; see the file COPYING.  If not,
 write to the Free Software Foundation, Inc., 675 Mass Ave, 
 Cambridge, MA 02139, USA.
*/


/* Don't put the following include inside the if ... endif */
/* Include(s): */
#include <Xarm/Shell.h>

#if !defined(_XARM_VENDORS_H_)
#define _XARM_VENDORS_H_

class VendorShellClass : public WMShellClass {
 protected:
   VendorShellClass() {}
   
   virtual WidgetClass classPointer() { return vendorShellWidgetClass; }
   virtual _XtString className() { return (_XtString) "VendorShell"; }
 public:
   /* extra functionality */
   void deleteWindowCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void saveYourselfCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void takeFocusCallback(XtCallbackProc funcp, XtPointer data = NULL);

   /* resources */
   void audibleWarning(unsigned char);
   unsigned char audibleWarning();
   XmFontList defaultFontList();
   void deleteResponse(unsigned char);
   unsigned char deleteResponse();
   void inputMethod(_XtString);
   _XtString inputMethod();
   void keyboardFocusPolicy(unsigned char);
   unsigned char keyboardFocusPolicy();
   void mwmDecorations(int);
   int mwmDecorations();
   void mwmFunctions(int);
   int mwmFunctions();
   void mwmInputMode(int);
   int mwmInputMode();
   void mwmMenu(_XtString);
   _XtString mwmMenu();
   void preeditType(_XtString);
   _XtString preeditType();
   void shellUnitType(unsigned char);
   unsigned char shellUnitType();
   void useAsyncGeometry(Boolean);
   Boolean useAsyncGeometry();
};

#endif

