/* ConRes.C,v 1.3 1995/11/30 04:19:03 pgw Exp */
/*
 Copyright (C) 1993, 1994 Jettero Heller
 Copyright (C) 1994, 1995 Peter Williams
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public License 
 version 2 as published by the Free Software Foundation.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; see the file COPYING.  If not,
 write to the Free Software Foundation, Inc., 675 Mass Ave, 
 Cambridge, MA 02139, USA.
*/

#include <Xarm/ConRes.h>

/* form constraint resources for its children */
void 
FormConstraintResources::bottomAttachment(unsigned char c)
{
   XtVaSetValues(widget(),XmNbottomAttachment,c,NULL);
}

unsigned char 
FormConstraintResources::bottomAttachment()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNbottomAttachment,&c,NULL);
   return c;
}

void 
FormConstraintResources::bottomOffset(int i)
{
   XtVaSetValues(widget(),XmNbottomOffset,i,NULL);
}

int 
FormConstraintResources::bottomOffset()
{
   int i;
   XtVaGetValues(widget(),XmNbottomOffset,&i,NULL);
   return i;
}

void 
FormConstraintResources::bottomPosition(int i)
{
   XtVaSetValues(widget(),XmNbottomPosition,i,NULL);
}

int 
FormConstraintResources::bottomPosition()
{
   int i;
   XtVaGetValues(widget(),XmNbottomPosition,&i,NULL);
   return i;
}

void 
FormConstraintResources::bottomWidget(Widget w)
{
   XtVaSetValues(widget(),XmNbottomWidget,w,NULL);
}

Widget 
FormConstraintResources::bottomWidget()
{
   Widget w;
   XtVaGetValues(widget(),XmNbottomWidget,&w,NULL);
   return w;
}

void 
FormConstraintResources::leftAttachment(unsigned char c)
{
   XtVaSetValues(widget(),XmNleftAttachment,c,NULL);
}

unsigned char 
FormConstraintResources::leftAttachment()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNleftAttachment,&c,NULL);
   return c;
}

void 
FormConstraintResources::leftOffset(int i)
{
   XtVaSetValues(widget(),XmNleftOffset,i,NULL);
}

int 
FormConstraintResources::leftOffset()
{
   int i;
   XtVaGetValues(widget(),XmNleftOffset,&i,NULL);
   return i;
}

void 
FormConstraintResources::leftPosition(int i)
{
   XtVaSetValues(widget(),XmNleftPosition,i,NULL);
}

int 
FormConstraintResources::leftPosition()
{
   int i;
   XtVaGetValues(widget(),XmNleftPosition,&i,NULL);
   return i;
}

void 
FormConstraintResources::leftWidget(Widget w)
{
   XtVaSetValues(widget(),XmNleftWidget,w,NULL);
}

Widget 
FormConstraintResources::leftWidget()
{
   Widget w;
   XtVaGetValues(widget(),XmNleftWidget,&w,NULL);
   return w;
}

void 
FormConstraintResources::resizable(Boolean b)
{
   XtVaSetValues(widget(),XmNresizable,b,NULL);
}

Boolean 
FormConstraintResources::resizable()
{
   Boolean b;
   XtVaGetValues(widget(),XmNresizable,&b,NULL);
   return b;
}

void 
FormConstraintResources::rightAttachment(unsigned char c)
{
   XtVaSetValues(widget(),XmNrightAttachment,c,NULL);
}

unsigned char 
FormConstraintResources::rightAttachment()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNrightAttachment,&c,NULL);
   return c;
}

void 
FormConstraintResources::rightOffset(int i)
{
   XtVaSetValues(widget(),XmNrightOffset, i,NULL);
}

int 
FormConstraintResources::rightOffset()
{
   int i;
   XtVaGetValues(widget(),XmNrightOffset, &i,NULL);
   return i;
}

void 
FormConstraintResources::rightPosition(int i)
{
   XtVaSetValues(widget(),XmNrightPosition, i,NULL);
}

int 
FormConstraintResources::rightPosition()
{
   int i;
   XtVaGetValues(widget(),XmNrightPosition, &i,NULL);
   return i;
}

void 
FormConstraintResources::rightWidget(Widget w)
{
   XtVaSetValues(widget(),XmNrightWidget, w,NULL);
}

Widget 
FormConstraintResources::rightWidget()
{
   Widget w;
   XtVaGetValues(widget(),XmNrightWidget, &w,NULL);
   return w;
}

void 
FormConstraintResources::topAttachment(unsigned char c)
{
   XtVaSetValues(widget(),XmNtopAttachment,c,NULL);
}

unsigned char 
FormConstraintResources::topAttachment()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNtopAttachment,&c,NULL);
   return c;
}

void 
FormConstraintResources::topOffset(int i)
{
   XtVaSetValues(widget(),XmNtopOffset, i,NULL);
}

int 
FormConstraintResources::topOffset()
{
   int i;
   XtVaGetValues(widget(),XmNtopOffset, &i,NULL);
   return i;
}

void 
FormConstraintResources::topPosition(int i)
{
   XtVaSetValues(widget(),XmNtopPosition, i,NULL);
}

int 
FormConstraintResources::topPosition()
{
   int i;
   XtVaGetValues(widget(),XmNtopPosition, &i,NULL);
   return i;
}

void 
FormConstraintResources::topWidget(Widget w)
{
   XtVaSetValues(widget(),XmNrightWidget, w,NULL);
}

Widget 
FormConstraintResources::topWidget() 
{
   Widget w;
   XtVaGetValues(widget(),XmNrightWidget, &w,NULL);
   return w;
}

/* Frame constraint resources for its children */
void
FrameConstraintResources::childType(unsigned char c)
{
   XtVaSetValues(widget(),XmNchildType,c, NULL);
}

unsigned char
FrameConstraintResources::childType()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNchildType, &c, NULL);
   return c;
}

void
FrameConstraintResources::childHorizontalAlignment(unsigned char c)
{
   XtVaSetValues(widget(),XmNchildHorizontalAlignment,c, NULL);
}

unsigned char
FrameConstraintResources::childHorizontalAlignment()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNchildHorizontalAlignment, &c, NULL);
   return c;
}

void
FrameConstraintResources::childHorizontalSpacing(unsigned char c)
{
   XtVaSetValues(widget(),XmNchildHorizontalSpacing,c, NULL);
}

unsigned char
FrameConstraintResources::childHorizontalSpacing()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNchildHorizontalSpacing, &c, NULL);
   return c;
}

void
FrameConstraintResources::childVerticalAlignment(unsigned char c)
{
   XtVaSetValues(widget(),XmNchildVerticalAlignment,c, NULL);
}

unsigned char
FrameConstraintResources::childVerticalAlignment()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNchildVerticalAlignment, &c, NULL);
   return c;
}

/* Paned Window constraint resources for it's children */
void
PanedWindowConstraintResources::allowResize(Boolean v)
{
   XtVaSetValues(widget(),XmNallowResize,v,NULL);
}

Boolean 
PanedWindowConstraintResources::allowResize()
{
   Boolean v;
   XtVaGetValues(widget(),XmNallowResize, &v, NULL);
   return v;
}

void 
PanedWindowConstraintResources::paneMaximum(Dimension v)
{
   XtVaSetValues(widget(),XmNpaneMaximum, v, NULL);
}

Dimension PanedWindowConstraintResources::paneMaximum()
{
   Dimension v;
   XtVaGetValues(widget(),XmNpaneMaximum, &v, NULL);
   return v;
}

void PanedWindowConstraintResources::paneMinimum(Dimension v)
{
   XtVaSetValues(widget(),XmNpaneMinimum, v, NULL);
}

Dimension PanedWindowConstraintResources::paneMinimum()
{
   Dimension v;
   XtVaGetValues(widget(),XmNpaneMinimum, &v, NULL);
   return v;
}

void PanedWindowConstraintResources::positionIndex(short v)
{
   XtVaSetValues(widget(),XmNpositionIndex, v, NULL);
}

short PanedWindowConstraintResources::positionIndex()
{
   short v;
   XtVaGetValues(widget(),XmNpositionIndex, &v, NULL);
   return v;
}

void PanedWindowConstraintResources::skipAdjust(Boolean v)
{
   XtVaSetValues(widget(),XmNskipAdjust, v, NULL);
}

Boolean PanedWindowConstraintResources::skipAdjust()
{
   Boolean v;
   XtVaGetValues(widget(),XmNskipAdjust, &v, NULL);
   return v;
}

/* RowColumn constraint resources for its children */
void 
RowColumnConstraintResources::positionIndex(short s)
{
   XtVaSetValues(widget(), XmNpositionIndex, s, NULL);
}

short 
RowColumnConstraintResources::positionIndex()
{
   short s;
   XtVaGetValues(widget(), XmNpositionIndex, &s, NULL);
   return s;
}


