/* DrawingA.C,v 1.6 1996/03/08 04:46:17 pgw Exp */
/*
 Copyright (C) 1993, 1994 Jettero Heller
 Copyright (C) 1994, 1995 Peter Williams
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public License 
 version 2 as published by the Free Software Foundation.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; see the file COPYING.  If not,
 write to the Free Software Foundation, Inc., 675 Mass Ave, 
 Cambridge, MA 02139, USA.
*/

#include <Xarm/DrawingA.h>

/* DrawingAreaClass Members */
/* Callbacks */
void
DrawingAreaClass::exposeCallback(XtCallbackProc funcp, XtPointer data)
{
   addCallback(XmNexposeCallback,funcp,data);
}

void
DrawingAreaClass::inputCallback(XtCallbackProc funcp, XtPointer data)
{
   addCallback(XmNinputCallback,funcp,data);
}

void
DrawingAreaClass::resizeCallback(XtCallbackProc funcp, XtPointer data)
{
   addCallback(XmNresizeCallback,funcp,data);
}

/* resources */
void
DrawingAreaClass::marginHeight(Dimension h)
{
   XtVaSetValues(widget(),XmNmarginHeight, h, NULL);
}

Dimension
DrawingAreaClass::marginHeight()
{
   Dimension h;
   XtVaGetValues(widget(),XmNmarginHeight, &h, NULL);
   return h;
}

void
DrawingAreaClass::marginWidth(Dimension w)
{
   XtVaSetValues(widget(),XmNmarginWidth, w, NULL);
}

Dimension
DrawingAreaClass::marginWidth()
{
   Dimension w;
   XtVaGetValues(widget(),XmNmarginWidth, &w, NULL);
   return w;
}

void
DrawingAreaClass::resizePolicy(unsigned char policy)
{
   XtVaSetValues(widget(),XmNresizePolicy, policy, NULL);
}

unsigned char
DrawingAreaClass::resizePolicy()
{
   unsigned char c;
   XtVaGetValues(widget(),XmNresizePolicy, &c, NULL);
   return c;
}

/* constructor */
DrawingArea::DrawingArea(Widget w_parent,
                         ArgList arglist,
                         Cardinal cnt,
                         _XtString name)
{
   Widget wid = createWidget(name, w_parent, arglist, cnt);
   widget(wid);
   manage();
}

DrawingArea::DrawingArea(_XtString name, Widget w_parent)
{
   Widget wid = createWidget(name, w_parent);
   widget(wid);
   manage();
}

