/* MainW.C,v 1.6 1996/03/08 04:46:24 pgw Exp */
/*
 Copyright (C) 1993, 1994 Jettero Heller
 Copyright (C) 1994, 1995 Peter Williams
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public License 
 version 2 as published by the Free Software Foundation.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; see the file COPYING.  If not,
 write to the Free Software Foundation, Inc., 675 Mass Ave, 
 Cambridge, MA 02139, USA.
*/

#include <assert.h>
#include <Xarm/MainW.h>
/* MainWindowClass members */

/* convenience routines */
Widget
MainWindowClass::separator1()
{
  return XmMainWindowSep1(widget());
}

Widget
MainWindowClass::separator2()
{
  return XmMainWindowSep1(widget());
}

Widget
MainWindowClass::separator3()
{
  return XmMainWindowSep1(widget());
}
      
void
MainWindowClass::setArea(Widget menu,
	Widget command,
	Widget hscroll,
	Widget vscroll,
	Widget work)
{
   XmMainWindowSetAreas(widget(),menu,command,hscroll,vscroll,work);
}

/* resources */
void
MainWindowClass::commandWindow(Widget w)
{
   XtVaSetValues(widget(), XmNcommandWindow, w, NULL);
}

Widget
MainWindowClass::commandWindow()
{
   Widget w;
   XtVaGetValues(widget(), XmNcommandWindow, &w, NULL);
   return w;
}

unsigned char
MainWindowClass::commandWindowLocation()
{
   unsigned char c;
   XtVaGetValues(widget(), XmNcommandWindowLocation, &c, NULL);
   return c;
}

void
MainWindowClass::mainWindowMarginHeight(Dimension d)
{
   XtVaSetValues(widget(), XmNmainWindowMarginHeight, d, NULL);
}

Dimension
MainWindowClass::mainWindowMarginHeight()
{
   Dimension d;
   XtVaGetValues(widget(), XmNmainWindowMarginHeight, &d, NULL);
   return d;
}

void
MainWindowClass::mainWindowMarginWidth(Dimension d)
{
   XtVaSetValues(widget(), XmNmainWindowMarginWidth, d, NULL);
}

Dimension
MainWindowClass::mainWindowMarginWidth()
{
   Dimension d;
   XtVaGetValues(widget(), XmNmainWindowMarginWidth, &d, NULL);
   return d;
}

void
MainWindowClass::menuBar(Widget w)
{
   XtVaSetValues(widget(), XmNmenuBar, w, NULL);
}

Widget
MainWindowClass::menuBar()
{
   Widget w;
   XtVaGetValues(widget(), XmNmenuBar, &w, NULL);
   return w;
}

void
MainWindowClass::messageWindow(Widget w)
{
   XtVaSetValues(widget(), XmNmessageWindow, w, NULL);
}

Widget
MainWindowClass::messageWindow()
{
   Widget w;
   XtVaGetValues(widget(), XmNmessageWindow, &w, NULL);
   return w;
}

void
MainWindowClass::showSeparator(Boolean b)
{
   XtVaSetValues(widget(), XmNshowSeparator, b, NULL);
}

Boolean
MainWindowClass::showSeparator()
{
   Boolean b;
   XtVaGetValues(widget(), XmNshowSeparator, &b, NULL);
   return b;
}

/* class constructor */
MainWindow::MainWindow(Widget w_parent, 
                       unsigned char policy,
                       Boolean show_separator, 
                       _XtString name)
{
   Arg args[2];
   Cardinal cnt = 0;

   XtSetArg(args[cnt], XmNscrollingPolicy, policy); cnt++;
   XtSetArg(args[cnt], XmNshowSeparator, show_separator); cnt++;

   assert(cnt <= (XtNumber(args)));

   Widget w = createWidget(name, w_parent, args, cnt);
   widget(w);

/*
   Widget w = XtVaCreateWidget("XmMainWindow",
                               xmMainWindowWidgetClass,
                               w_parent,
                               XmNscrollingPolicy, policy,
                               XmNshowSeparator, show_separator,
                               NULL);
*/
}

MainWindow::MainWindow(Widget w_parent,
                       Dimension w, 
                       Dimension h, 
                       unsigned char policy,
                       Boolean show_separator,
                       _XtString name)
{
   Arg args[4];
   Cardinal cnt = 0;

   XtSetArg(args[cnt], XmNwidth, w); cnt++;
   XtSetArg(args[cnt], XmNheight, h); cnt++;
   XtSetArg(args[cnt], XmNscrollingPolicy, policy); cnt++;
   XtSetArg(args[cnt], XmNshowSeparator, show_separator); cnt++;

   assert(cnt <= (XtNumber(args)));

   Widget wid = createWidget(name, w_parent, args, cnt);
                                
   widget(wid);
}

MainWindow::MainWindow(Widget w_parent,
                       ArgList arglist,
                       Cardinal cnt,
                       _XtString name)
{
   Widget wid = createWidget(name, w_parent, arglist, cnt);
   widget(wid);
}

MainWindow::MainWindow(_XtString name, Widget w_parent)
{
   Widget wid = createWidget(name, w_parent);
   widget(wid);
}

